Unit iah4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAH1E_p;

procedure iah4e(A :Extended; B :Extended; var C :Array of Extended;
                N :Integer; FUNC :Func_F1E;
                var CINT :Array of Extended; var RF :Array of Extended);

implementation

procedure iah4e(A :Extended; B :Extended; var C :Array of Extended;
                N :Integer; FUNC :Func_F1E;
                var CINT :Array of Extended; var RF :Array of Extended);
var
N1,J :Integer;
CON,SUM,FAC :Extended;
label
_10;
begin
IAH1E(A,B,C,N,FUNC,RF);
CON := 0.25e0*(B-A);
SUM := 0.0e0;
FAC := 1.0e0;
N1 := N-1;
for J:=2 to N1 do
 begin
  CINT[J-1] := CON*(C[J-2]-C[J+0])/(J-1);
  SUM := SUM+FAC*CINT[J-1];
  FAC := -FAC;
_10:
 end;
CINT[N-1] := CON*C[N-2]/(N-1);
SUM := SUM+FAC*CINT[N-1];
CINT[0] := 2*SUM;
end;

end.
